package kr.co.icontrols.ilp300_700.admin.setting;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.widget.RelativeLayout;

import kr.co.icontrols.ilp300_700.MainActivity;
import kr.co.icontrols.ilp300_700.R;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValKey;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValue;
import kr.co.icontrols.ilp300_700.global.DataClasses.POSITION;
import kr.co.icontrols.ilp300_700.global.Declare;
import kr.co.icontrols.ilp300_700.global.Enumeration.DATAINPUTSTEP;
import kr.co.icontrols.ilp300_700.global.Global;
import kr.co.icontrols.ilp300_700.global.ID;
import kr.co.icontrols.wallpadsupport.WpadImageView;
import kr.co.icontrols.wallpadsupport.WpadScreen;
import kr.co.icontrols.wallpadsupport.WpadTextView;

public class AdminSet_Setting_OnePassConfigure extends WpadScreen {

    String TAG = "AdminSet_Setting_OnePassConfigure";

    boolean bLOG = true;   // true, false
    boolean bLOG_DEBUG = false;   // true, false
    boolean bLOG_INFO = true;   // true, false
    Context mContext;
    WpadImageView Image_Background;
    WpadTextView Text_Title;
    WpadTextView Text_Guide;
    WpadTextView Text_Line_01_Item;
    WpadTextView Text_Line_02_Item;
    WpadTextView Text_Line_03_Item;
    WpadTextView Text_Line_01_Input;
    WpadTextView Text_Line_02_Input;
    WpadTextView Text_Line_03_Input;

    int TextColor_Normal = Color.WHITE;
    int TextColor_Highlight = Color.GREEN;
    int nFontSize_Guide = 14;
    int nFontSize_Instruction = 28;
    boolean bFontNonBold = false;
    boolean bFontBold = true;

    String strText_Title = "원패스 환경설정";
    String strText_Guide = " * : 행 이동\n# : 보기 이동\n경비실 : 설정";
    String strText_Line_01_Item = "대기시간";
    String strText_Line_02_Item = "차단시간(In->Out)";
    String strText_Line_03_Item = "시험모드";
    String strText_Line_01_Input = "";
    String strText_Line_02_Input = "";
    String strText_Line_03_Input = "";

    public AdminSet_Setting_OnePassConfigure(Context context, RelativeLayout layout) {
        super(context, layout);
        try {
            LOG("------------------ [START - AdminSet_Setting_OnePassConfigure] -------------------");

            mContext = context;
            Initialize();

            Image_Background = new WpadImageView(context, 0, Declare.DeviceInfo.getScreenSizeFullW(ConfigValue.DEVICE_MODELTYPE), Declare.DeviceInfo.getScreenSizeFullH(ConfigValue.DEVICE_MODELTYPE), R.drawable.bg_back, 0, ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.IMAGES.BACKGROUND);
            ViewRegistration(layout, Image_Background, 0, 0);

            Text_Title = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.TITLE).W, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.TITLE).H, Gravity.CENTER, Color.WHITE, nFontSize_Instruction, bFontBold, ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.TITLE);
            ViewRegistration(layout, Text_Title, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.TITLE).X, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.TITLE).Y);
            Text_Title.setText(strText_Title);

            Text_Guide = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.GUIDE).W, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.GUIDE).H, Gravity.LEFT, Color.parseColor("#7d7d7d"), nFontSize_Guide, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.GUIDE);
            ViewRegistration(layout, Text_Guide, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.GUIDE).X, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.GUIDE).Y);
            Text_Guide.setText(strText_Guide);

            Text_Line_01_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Item);
            ViewRegistration(layout, Text_Line_01_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Item).Y);
            Text_Line_01_Item.setText(strText_Line_01_Item);

            Text_Line_02_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Item);
            ViewRegistration(layout, Text_Line_02_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Item).Y);
            Text_Line_02_Item.setText(strText_Line_02_Item);

            Text_Line_03_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Item);
            ViewRegistration(layout, Text_Line_03_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Item).Y);
            Text_Line_03_Item.setText(strText_Line_03_Item);

            Text_Line_01_Input = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Input).W, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Input).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Input);
            ViewRegistration(layout, Text_Line_01_Input, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Input).X, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Input).Y);
            Text_Line_01_Input.setText("[ " + strText_Line_01_Input + " ]");

            Text_Line_02_Input = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Input).W, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Input).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Input);
            ViewRegistration(layout, Text_Line_02_Input, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Input).X, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Input).Y);
            Text_Line_02_Input.setText("[ " + strText_Line_02_Input + " ]");

            Text_Line_03_Input = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Input).W, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Input).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Input);
            ViewRegistration(layout, Text_Line_03_Input, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Input).X, getPosition(ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Input).Y);
            Text_Line_03_Input.setText("[ " + strText_Line_03_Input + " ]");

            updateScreen();

            ((MainActivity) mContext).setAutoScreenChange(ID.SCREENS.Main, MainActivity.nAdminScreenTimeout);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] AdminSet_Setting_OnePassConfigure(Context context, RelativeLayout layout)");
            e.printStackTrace();
        }
    }

    private void LOG(String log) {
        if (bLOG) Log.v(TAG, log);
    }

    private void LOG_DEBUG(String log) {
        if (bLOG_DEBUG) Log.d(TAG, log);
    }

    private void LOG_INFO(String log) {
        if (bLOG_INFO) Log.i(TAG, log);
    }

    protected void Initialize() {
        try {
            Global.DataInputStep = DATAINPUTSTEP.INPUT_01;

            strText_Line_01_Input = Integer.toString(ConfigValue.nOnePassAvailableTime);
            strText_Line_02_Input = Integer.toString(ConfigValue.nOnePassInOutBlockTime);
            strText_Line_03_Input = (Global.bOnePassTestMode) ? "사용함" : "사용안함";

        } catch (Exception e) {
            Log.e(TAG, "[Exception] Initialize() : " + e);
            e.printStackTrace();
        }
    }

    @Override
    protected void onClose() {
        try {
            LOG("------------------ [onClose - AdminSet_Setting_OnePassConfigure] -------------------");
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onClose() : " + e);
            e.printStackTrace();
        }
        super.onClose();
    }

    @Override
    protected void onBrReceive(Intent intent) {
        try {
            LOG("[onBrReceive] Intent : " + intent);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onBrReceive(...) : " + e);
            e.printStackTrace();
        }
        super.onBrReceive(intent);
    }

    @Override
    protected void onKeyDown(int keyCode, KeyEvent event) {
        try {
            LOG("[onKeyDown] keyCode [" + keyCode + "]");
            if (Declare.Button.NUMBER_00 <= keyCode && keyCode <= Declare.Button.NUMBER_09) {
                if (Global.DataInputStep == DATAINPUTSTEP.INPUT_01) {
                    strText_Line_01_Input += keyCode - 7;

                    if (strText_Line_01_Input.length() > 2) {
                        strText_Line_01_Input = strText_Line_01_Input.substring(1);
                    }
                }
                else if (Global.DataInputStep == DATAINPUTSTEP.INPUT_02) {
                    strText_Line_02_Input += keyCode - 7;

                    if (strText_Line_02_Input.length() > 2) {
                        strText_Line_02_Input = strText_Line_02_Input.substring(1);
                    }
                    strText_Line_02_Input = String.valueOf(Integer.parseInt(strText_Line_02_Input));
                }
                updateScreen();
            }
            else if (keyCode == Declare.Button.STAR) {
                if (Global.DataInputStep == DATAINPUTSTEP.INPUT_01) {
                    Global.DataInputStep = DATAINPUTSTEP.INPUT_02;
                }
                else if (Global.DataInputStep == DATAINPUTSTEP.INPUT_02) {
                    Global.DataInputStep = DATAINPUTSTEP.INPUT_03;
                }
                else if (Global.DataInputStep == DATAINPUTSTEP.INPUT_03) {
                    Global.DataInputStep = DATAINPUTSTEP.INPUT_01;
                }
                updateScreen();
            }
            else if (keyCode == Declare.Button.SHARP) {
                if (Global.DataInputStep == DATAINPUTSTEP.INPUT_03) {
                    if (strText_Line_03_Input.equalsIgnoreCase("사용함")) strText_Line_03_Input = "사용안함";
                    else strText_Line_03_Input = "사용함";
                    updateScreen();
                }
            }
            else if (keyCode == Declare.Button.GUARD) {
                // 설정정보를 저장하는 기능을 정의한다.
                if (!setOnePassConfigure(strText_Line_01_Input, strText_Line_02_Input, (strText_Line_03_Input.equals("사용함")) ? true : false)) {
                    MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                }
                else {
                    MainActivity.mSound.PlayMent_lobby(R.raw.setting);
                }
                super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
            }
            else if (keyCode == Declare.Button.CANCEL || keyCode == Declare.Button.TACT_CANCEL) {
                super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onKeyDown(int keyCode, KeyEvent event)");
            e.printStackTrace();
        }
        super.onKeyDown(keyCode, event);
    }

    protected void updateScreen() {
        try {
//            LOG("[updateScreen] Start!!");
            if (Global.DataInputStep == DATAINPUTSTEP.INPUT_01) {
                Text_Line_01_Input.setText("[ " + strText_Line_01_Input + " ]");
                Text_Line_01_Item.setTextColor(TextColor_Highlight);
                Text_Line_02_Item.setTextColor(TextColor_Normal);
                Text_Line_03_Item.setTextColor(TextColor_Normal);
                Text_Line_01_Input.setTextColor(TextColor_Highlight);
                Text_Line_02_Input.setTextColor(TextColor_Normal);
                Text_Line_03_Input.setTextColor(TextColor_Normal);
            }
            else if (Global.DataInputStep == DATAINPUTSTEP.INPUT_02) {
                Text_Line_02_Input.setText("[ " + strText_Line_02_Input + " ]");
                Text_Line_01_Item.setTextColor(TextColor_Normal);
                Text_Line_02_Item.setTextColor(TextColor_Highlight);
                Text_Line_03_Item.setTextColor(TextColor_Normal);
                Text_Line_01_Input.setTextColor(TextColor_Normal);
                Text_Line_02_Input.setTextColor(TextColor_Highlight);
                Text_Line_03_Input.setTextColor(TextColor_Normal);
            }
            else if (Global.DataInputStep == DATAINPUTSTEP.INPUT_03) {
                Text_Line_03_Input.setText("[ " + strText_Line_03_Input + " ]");
                Text_Line_01_Item.setTextColor(TextColor_Normal);
                Text_Line_02_Item.setTextColor(TextColor_Normal);
                Text_Line_03_Item.setTextColor(TextColor_Highlight);
                Text_Line_01_Input.setTextColor(TextColor_Normal);
                Text_Line_02_Input.setTextColor(TextColor_Normal);
                Text_Line_03_Input.setTextColor(TextColor_Highlight);
            }
            else {
                Text_Line_01_Item.setTextColor(TextColor_Normal);
                Text_Line_02_Item.setTextColor(TextColor_Normal);
                Text_Line_03_Item.setTextColor(TextColor_Normal);
                Text_Line_01_Input.setTextColor(TextColor_Normal);
                Text_Line_02_Input.setTextColor(TextColor_Normal);
                Text_Line_03_Input.setTextColor(TextColor_Normal);
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] updateScreen()");
            e.printStackTrace();
        }
    }

    private POSITION getPosition(int nID) {
//        LOG("[getPosition] Start!!");
        POSITION position = new POSITION();
        position.SetPosition(0, 0, 480, 272);
        try {
            switch (nID) {
                case ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.IMAGES.BACKGROUND:
                    position.SetPosition(0, 0, 480, 272);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.TITLE:
                    position.SetPosition(0, 24, 480, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.GUIDE:
                    position.SetPosition(382, 10, 98, 55);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Item:
                    position.SetPosition(30, 73, 215, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Item:
                    position.SetPosition(30, 122, 215, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Item:
                    position.SetPosition(30, 171, 215, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_04_Item:
                    position.SetPosition(30, 220, 215, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_01_Input:
                    position.SetPosition(255, 73, 195, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_02_Input:
                    position.SetPosition(255, 122, 195, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_03_Input:
                    position.SetPosition(255, 171, 195, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_ONEPASSCONFIGURE.ELEMENTS.TEXTS.LINE_04_Input:
                    position.SetPosition(255, 220, 195, 40);
                    return position;

                default:
                    return position;
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] getPosition() : " + e);
            e.printStackTrace();
            return position;
        }
    }

    private boolean setOnePassConfigure(String strAvailableTime, String strInBlockTime, boolean bTestMode) {
        try {
            LOG("[setOnePassConfigure] strAvailableTime [" + strAvailableTime + "], strInBlockTime [" + strInBlockTime + "], bTestMode [" + bTestMode + "]");
            int nAvailableTime = Integer.parseInt(strAvailableTime);
            int nBlockTime = Integer.parseInt(strInBlockTime);

            if (1 <= nAvailableTime && nAvailableTime <= 99) {
                ConfigValue.nOnePassAvailableTime = nAvailableTime;
                if (!MainActivity.ConfigDBManager.setData(Declare.DBInfo.TABLE_NAME_CONFIG, ConfigValKey.OnePassAvailableTime, ConfigValue.nOnePassAvailableTime)) return false;
            }
            else {
                return false;
            }

            if (1 <= nBlockTime && nBlockTime <= 99) {
                ConfigValue.nOnePassInOutBlockTime = nBlockTime;
                if (!MainActivity.ConfigDBManager.setData(Declare.DBInfo.TABLE_NAME_CONFIG, ConfigValKey.OnePassInOutBlockTime, ConfigValue.nOnePassInOutBlockTime)) return false;
            }
            else {
                return false;
            }

            Global.bOnePassTestMode = bTestMode;

            return true;
        } catch (Exception e) {
            Log.e(TAG, "[Exception] setOnePassConfigure(String strAvailableTime, String strInBlockTime, boolean bPlaySound)");
            e.printStackTrace();
            return false;
        }
    }



}
